diff --git a/Units/parser-c.r/c-struct-var-with-initializer.d/args.ctags b/Units/parser-c.r/c-struct-var-with-initializer.d/args.ctags
new file mode 100644
index 0000000000..f259a0fa07
--- /dev/null
+++ b/Units/parser-c.r/c-struct-var-with-initializer.d/args.ctags
@@ -0,0 +1,3 @@
+--sort=no
+--kinds-c=+lz
+--fields=+K
diff --git a/Units/parser-c.r/c-struct-var-with-initializer.d/expected.tags b/Units/parser-c.r/c-struct-var-with-initializer.d/expected.tags
new file mode 100644
index 0000000000..39cf891c93
--- /dev/null
+++ b/Units/parser-c.r/c-struct-var-with-initializer.d/expected.tags
@@ -0,0 +1,10 @@
+__anon61565e570108	input.c	/^struct {$/;"	struct	file:
+a	input.c	/^  int a;$/;"	member	struct:__anon61565e570108	typeref:typename:int	file:
+b	input.c	/^} b = { 1 };$/;"	variable	typeref:struct:__anon61565e570108
+c	input.c	/^int c;$/;"	variable	typeref:typename:int
+d	input.c	/^int d(int e) {$/;"	function	typeref:typename:int
+e	input.c	/^int d(int e) {$/;"	parameter	function:d	typeref:typename:int	file:
+__anon61565e570208	input.c	/^  struct {$/;"	struct	function:d	file:
+f	input.c	/^    int f;$/;"	member	struct:d::__anon61565e570208	typeref:typename:int	file:
+g	input.c	/^  } g = { 1 };$/;"	local	function:d	typeref:struct:d::__anon61565e570208	file:
+h	input.c	/^  int h;$/;"	local	function:d	typeref:typename:int	file:
diff --git a/Units/parser-c.r/c-struct-var-with-initializer.d/input.c b/Units/parser-c.r/c-struct-var-with-initializer.d/input.c
new file mode 100644
index 0000000000..4504607f1b
--- /dev/null
+++ b/Units/parser-c.r/c-struct-var-with-initializer.d/input.c
@@ -0,0 +1,15 @@
+/* Derived from an issue (#1311) opened by BodoStroesser */
+
+struct {
+  int a;
+} b = { 1 };
+
+int c;
+
+int d(int e) {
+  struct {
+    int f;
+  } g = { 1 };
+  int h;
+  g = (typeof(g)){ 2 };
+}
diff --git a/parsers/cxx/cxx_parser.c b/parsers/cxx/cxx_parser.c
index 544ef00032..b5f45f7ede 100644
--- a/parsers/cxx/cxx_parser.c
+++ b/parsers/cxx/cxx_parser.c
@@ -399,7 +399,8 @@ static bool cxxParserParseEnumStructClassOrUnionFullDeclarationTrailer(
 	MIOPos oFilePosition = getInputFilePosition();
 	int iFileLine = getInputLineNumber();
 
-	if(!cxxParserParseUpToOneOf(CXXTokenTypeEOF | CXXTokenTypeSemicolon | CXXTokenTypeOpeningBracket))
+	if(!cxxParserParseUpToOneOf(CXXTokenTypeEOF | CXXTokenTypeSemicolon | CXXTokenTypeOpeningBracket
+								| CXXTokenTypeAssignment))
 	{
 		CXX_DEBUG_LEAVE_TEXT("Failed to parse up to EOF/semicolon");
 		return false;
@@ -465,6 +466,25 @@ static bool cxxParserParseEnumStructClassOrUnionFullDeclarationTrailer(
 	else
 		cxxParserExtractVariableDeclarations(g_cxx.pTokenChain,0);
 
+	/*
+	  Skip initializer in
+
+	  struct foo { ... } x = { ... };
+
+	  if we are at --------^.
+	  we go to ---------------------^.
+
+	  The above example is known case.
+	  To be tolerant and handle unrecognized case, we
+	  put the code for skipping here. */
+	if(cxxTokenTypeIs(g_cxx.pToken,CXXTokenTypeAssignment) &&
+	   (!cxxParserParseUpToOneOf(CXXTokenTypeEOF | CXXTokenTypeSemicolon)))
+	{
+		CXX_DEBUG_LEAVE_TEXT("Failed to parse up to EOF/semicolon");
+		return false;
+	}
+
+
 	CXX_DEBUG_LEAVE();
 	return true;
 }
